package net.beaumaris.cachetest;

import java.io.Serializable;
import java.util.UUID;

public class AddTask extends BaseTask<Integer, String, Integer, Integer> implements Serializable {

   private static final long serialVersionUID = 1L;

   private final int key;
   private final int amount;

   public AddTask(int key, int amount) {
      this.key = key;
      this.amount = amount;
   }

   @Override
   protected String doTx() {

      allocCache.getAdvancedCache().lock(key);

      Integer value = allocCache.get(key);
      if (value == null) {
         value = new Integer(0);
      }

      value += amount;
      allocCache.put(key, value);

      String uuid = UUID.randomUUID().toString();
      this.uuidCache.put(uuid, key);
      return uuid;
   }
}
