package net.beaumaris.cachetest;

import java.util.concurrent.atomic.AtomicInteger;

/**
 * Common state to verify cache behavior
 */
public final class SharedStats {

   public final AtomicInteger allocateSuccessCounter = new AtomicInteger(0);
   public final AtomicInteger deallocateSuccessCounter = new AtomicInteger(0);
   public final AtomicInteger rollbackCounter = new AtomicInteger(0);
   public final AtomicInteger allocateFailedCounter = new AtomicInteger(0);
   public final AtomicInteger timeoutCounter = new AtomicInteger(0);
   public final AtomicInteger deallocateFailedCounter = new AtomicInteger(0);
   public Throwable throwable = null;
   public volatile boolean globalQuit = false; // when it's true the threads quit
   public volatile boolean seenFailures = false; // set to true by a thread if it

   // has experienced

   // illegal state

   public String toString() {
      return "\n\tSuccessful allocation count:\t" + allocateSuccessCounter.get()
             + "\n\tSuccessful deallocation count:\t"
             + deallocateSuccessCounter.get()
             + "\n\tRollback tx count:\t"
             + rollbackCounter.get()
             + "\n\tFailed allocation count:\t"
             + allocateFailedCounter.get()
             + "\n\tFailed deallocation count:\t"
             + deallocateFailedCounter.get()
             + "\n\tOther cache exception count:\t"
             + timeoutCounter.get()
             + "\n\tIllegal state detected:\t"
             + seenFailures;
   }
}
