package net.beaumaris.cachetest;

import java.io.Serializable;

public class SubtractTask extends BaseTask<Integer, Integer, Integer, Integer> implements Serializable {

   private static final long serialVersionUID = 1L;

   private final String uuid;
   private final int amount;

   public SubtractTask(String uuid, int amount) {
      this.uuid = uuid;
      this.amount = amount;
   }

   @Override
   protected Integer doTx() {

      Integer key = this.uuidCache.get(uuid);
      if (key == null)
         return -1;

      this.allocCache.getAdvancedCache().lock(key);
      Integer value = allocCache.get(key);
      if (value == null) {
         value = new Integer(0);
      }

      value -= amount;
      allocCache.put(key, value);

      uuidCache.remove(uuid);
      return 0;
   }
}
