package net.beaumaris.cachetest.group;

import java.io.Serializable;
import java.text.MessageFormat;

import net.beaumaris.cachetest.BaseTask;

public class DeallocateTask extends BaseTask<GroupedKey, Integer, AllocResource, Session> implements Serializable {

   /**
    * Default UUID.
    */
   private static final long serialVersionUID = 1L;

   private final String uuid;

   public DeallocateTask(String uuid) {
      this.uuid = uuid;
   }

   @Override
   protected Integer doTx() throws Exception {

      Session resource = this.uuidCache.get(uuid);
      if (resource == null)
         return -1;

      this.allocCache.getAdvancedCache().lock(resource.getKey());
      AllocResource value = allocCache.get(resource.getKey());
      if (value == null) {
         throw new RuntimeException(MessageFormat.format("DeallocateTask::doTx(). Could not find resource for session: {0}", uuid));
      }

      value.releaseResource(resource.getAmount(), resource.getIndex(), uuid);
      allocCache.replace(resource.getKey(), value);

      uuidCache.remove(uuid);
      return 0;
   }
}
