package net.beaumaris.cachetest.group;

import java.io.Serializable;
import java.text.MessageFormat;

public class MockResource implements Serializable {

   /**
    * Default UID.
    */
   private static final long serialVersionUID = 1L;

   public enum ResourceState {
      UNUSED, USED;
   }

   private String uuid;
   private ResourceState state = ResourceState.UNUSED;

   public MockResource() {
   }

   public void assignSession(String uuid) {
      this.uuid = uuid;
      this.state = ResourceState.USED;
   }

   public void removeSession(String uuid) {

      if (!this.uuid.equalsIgnoreCase(uuid)) {
         throw new RuntimeException(MessageFormat.format("MockResource::removeSession. Expected {0}.  Received {1}", this.uuid, uuid));
      }

      this.uuid = "";
      this.state = ResourceState.UNUSED;
   }

   public ResourceState getResourceState() {
      return this.state;
   }
}
